/* The following code example is taken from the book
 * "The C++ Standard Library - A Tutorial and Reference"
 * by Nicolai M. Josuttis, Addison-Wesley, 1999
 *
 * (C) Copyright Nicolai M. Josuttis 1999.
 * Permission to copy, use, modify, sell and distribute this software
 * is granted provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied
 * warranty, and with no claim as to its suitability for any purpose.
 */
#include "algostuff.hpp"
using namespace std;

bool bothEvenOrOdd (int elem1, int elem2)
{
    return elem1 % 2 == elem2 % 2;
}

int main()
{
    vector<int> coll1;
    list<int> coll2;

    INSERT_ELEMENTS(coll1,1,7);
    INSERT_ELEMENTS(coll2,3,9);

    PRINT_ELEMENTS(coll1,"coll1: ");
    PRINT_ELEMENTS(coll2,"coll2: ");

    // sprawdz, czy obydwie kolekcje sa rowne
    if (equal (coll1.begin(), coll1.end(),  // pierwszy zakres
               coll2.begin())) {            // drugi zakres
        cout << "coll1 == coll2" << endl;
    }
    else {
        cout << "coll1 != coll2" << endl;
    }

    // sprawdz pokrywanie sie elementow parzystych i nieparzystych
    if (equal (coll1.begin(), coll1.end(),  // pierwszy zakres
               coll2.begin(),               // drugi zakres
               bothEvenOrOdd)) {            // kryterium porownania
        cout << "elementy parzyste i nieparzyste pokrywaja sie" << endl;
    }
    else {
        cout << "elementy parzyste i nieparzyste nie pokrywaja sie" << endl;
    }
}


