/* The following code example is taken from the book
 * "The C++ Standard Library - A Tutorial and Reference"
 * by Nicolai M. Josuttis, Addison-Wesley, 1999
 *
 * (C) Copyright Nicolai M. Josuttis 1999.
 * Permission to copy, use, modify, sell and distribute this software
 * is granted provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied
 * warranty, and with no claim as to its suitability for any purpose.
 */
#include <cstdlib>
#include "algostuff.hpp"
using namespace std;

class MyRandom {
  public:
    ptrdiff_t operator() (ptrdiff_t max) {
        double tmp;
        tmp = static_cast<double>(rand())
                / static_cast<double>(RAND_MAX);
        return static_cast<ptrdiff_t>(tmp * max);
    }
};

int main()
{
    vector<int> coll;

    INSERT_ELEMENTS(coll,1,9);
    PRINT_ELEMENTS(coll,"coll:        ");

    // potasuj losowo wszystkie elementy
    random_shuffle (coll.begin(), coll.end());

    PRINT_ELEMENTS(coll,"potasowane:  ");

    // posortuj je ponownie
    sort (coll.begin(), coll.end());
    PRINT_ELEMENTS(coll,"posortowane: ");

    /* potasuj elementy z wykorzystaniem samodzielnie napisanego generatora liczb losowych
     * - aby przekazac l-wartosc musimy zastosowac obiekt tymczasowy
     */
    MyRandom rd;
    random_shuffle (coll.begin(), coll.end(),    // zakres
                    rd);                 // generator liczb losowych

    PRINT_ELEMENTS(coll,"potasowane:  ");
}
