/* The following code example is taken from the book
 * "The C++ Standard Library - A Tutorial and Reference"
 * by Nicolai M. Josuttis, Addison-Wesley, 1999
 *
 * (C) Copyright Nicolai M. Josuttis 1999.
 * Permission to copy, use, modify, sell and distribute this software
 * is granted provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied
 * warranty, and with no claim as to its suitability for any purpose.
 */

#include <iostream>
#include <list>
#include <algorithm>
#include "print.hpp"
using namespace std;

int main()
{
    list<int> coll;

    // utworz wstawiacz poczatkowy dla kontenera coll
    // - niewygodny sposob
    front_insert_iterator<list<int> > iter(coll);

    // wstaw elementy z wykorzystaniem typowego interfejsu iteratora
    *iter = 1;
    iter++;
    *iter = 2;
    iter++;
    *iter = 3;

    PRINT_ELEMENTS(coll);

    // utworz wstawiacz poczatkowy i wstaw elementy
    // - wygodny sposob
    front_inserter(coll) = 44;
    front_inserter(coll) = 55;

    PRINT_ELEMENTS(coll);

    // uzyj wstawiacza poczatkowego do ponownego wstawienia wszystkich elementow
    copy (coll.begin(), coll.end(),    // zrodlo
          front_inserter(coll));       // przeznaczenie

    PRINT_ELEMENTS(coll);
}
